<id>
Smart Image Resize SP1-1.1
</id>

<version>
Beta 7
</version>

<mod info>
This mod uses javascript to resize avatars and pictures inserted using the [img] tag if they exceed a maximum size, while maintaining the original aspect ratio of the image.


Install Instructions:
	1..Apply the mod as usual (Consult the BoardMod FAQ if you are unsure how to do this).
	2..If you would like to restrict the size of attached images, install the "File Attachments" patch file.
	3..Upload the modified files to your server.
	4..Go to the "Forum Preferences and Settings" and set the values for the maximum image sizes.


Notes:
	1..The maximum allowed image width and height are set in the forum preferences and settings admin area.
	2..There are seperate settings for: images in messages and images in signatures.
	3..The [img] tag can now contain width=???, height=???, align=??? and alt=??? attributes in any order or combination.
	4..The align attribute can take the standard align values of the <img> tag (left, right, top, texttop, middle, absmiddle, baseline, bottom, absbottom).
	5..If you specify the width or height, the image will be resized to that width or height while maintaining the aspect ratio of the original image. 
	6..If you specify both the width and height, the image will be resized to the size specified, adopting the specified aspect ratio.
	7..If the image exceeds the maximum allowed size, it will be resized to the maximum allowed size while maintaining it's original aspect ratio or the specified aspect ratio.
	8..If the users browser does not support javascript, the normal (unresized) image will be displayed.
	9..Now includes the [img] tag bugfix by Michael Prager, and images are restricted to files with a .gif, .jpg, .png or .bmp extension.
</mod info>

<author>
BHRA Webmaster
</author>

<homepage>
http://www.bhra.org.uk
</homepage>

####################################################################################

<edit file>
template.html
</edit file>

<search for>
</head>
</search for>

<add before>
	<script language="JavaScript1.2" type="text/javascript">
	<!--
	function resize_img(thisimage, maxwidth, maxheight, specwidth, specheight) {
		if (document.images) {
			tmp_image = new Image;
			tmp_image.src = thisimage.src;
			var tmpwidth = tmp_image.width;
			var tmpheight = tmp_image.height;

			if (specwidth != 0 && specheight != 0) {
				tmpwidth = specwidth;
				tmpheight = specheight;
			}
			if (specwidth != 0 && specheight == 0) {
				tmpheight = (tmpheight * specwidth / tmpwidth);
				tmpwidth = specwidth;
			}
			if (specwidth == 0 && specheight != 0) {
				tmpwidth = (tmpwidth * specheight / tmpheight);
				tmpheight = specheight;
			}

			if (maxwidth != 0 && tmpwidth > maxwidth) {
				tmpheight = (tmpheight * maxwidth / tmpwidth);
				tmpwidth = maxwidth;
			}

			if (maxheight != 0 && tmpheight > maxheight) {
				tmpwidth = tmpwidth * maxheight / tmpheight;
				tmpheight = maxheight;
			}

			thisimage.width = tmpwidth;
			thisimage.height = tmpheight;
			thisimage.style.display = 'inline';
		}
	}
	// -->
	</script>
</add before>

####################################################################################

<edit file>
english.lng
</edit file>

<search for>
$txt{'476'} = "Userpic Width (0 = disable limit)";
$txt{'477'} = "Userpic Height (0 = disable limit)";
</search for>

<replace>
$txt{'476a'} = "Maximum Userpic Size (0 = disable limit)";
$txt{'476b'} = "Maximum Image Size (0 = disable limit)";
$txt{'476c'} = "Maximum Signature Image Size (0 = disable limit)";
$txt{'477a'} = "Width:";
$txt{'477b'} = "Height:";
</replace>

####################################################################################

<edit file>
Sources/AdminEdit.pl
</edit file>

<search for>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'476'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="userpic_width" size="5" value="$userpic_width"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'477'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="userpic_height" size="5" value="$userpic_height"></td>
  </tr><tr>
</search for>

<replace>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'476b'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'477a'} <input type="text" name="MAXIMGWIDTH" size="5" value="$MAXIMGWIDTH"> &nbsp; &nbsp; $txt{'477b'} <input type=text name="MAXIMGHEIGHT" size="5" value="$MAXIMGHEIGHT"></font></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'476c'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'477a'} <input type="text" name="MAXSIGWIDTH" size="5" value="$MAXSIGWIDTH"> &nbsp; &nbsp; $txt{'477b'} <input type=text name="MAXSIGHEIGHT" size="5" value="$MAXSIGHEIGHT"></font></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'476a'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'477a'} <input type="text" name="userpic_width" size="5" value="$userpic_width"> &nbsp; &nbsp; $txt{'477b'} <input type=text name="userpic_height" size="5" value="$userpic_height"></font></td>
  </tr><tr>
</replace>

<search for>
	if ($FORM{'userpic_width'} =~ /\d+/)  { $userpic_width  = $FORM{'userpic_width'};  }
	else { $userpic_width = 65; }
</search for>

<add before>
	if ($FORM{'MAXIMGWIDTH'} =~ /\d+/)  { $MAXIMGWIDTH  = $FORM{'MAXIMGWIDTH'};  }
	else { $MAXIMGWIDTH = 0; }
	if ($FORM{'MAXIMGHEIGHT'} =~ /\d+/)  { $MAXIMGHEIGHT  = $FORM{'MAXIMGHEIGHT'};  }
	else { $MAXIMGHEIGHT = 0; }
	if ($FORM{'MAXSIGWIDTH'} =~ /\d+/)  { $MAXSIGWIDTH  = $FORM{'MAXSIGWIDTH'};  }
	else { $MAXSIGWIDTH = 0; }
	if ($FORM{'MAXSIGHEIGHT'} =~ /\d+/)  { $MAXSIGHEIGHT  = $FORM{'MAXSIGHEIGHT'};  }
	else { $MAXSIGHEIGHT = 0; }
</add before>

<search for>
\$userpic_width = $userpic_width;			# Set pixel size to which the selfselected userpics are resized, 0 disables this limit
</search for>

<add before>
\$MAXIMGWIDTH = $MAXIMGWIDTH;				# Set maximum pixel width for images, 0 disables this limit
\$MAXIMGHEIGHT = $MAXIMGHEIGHT;				# Set maximum pixel height for images, 0 disables this limit
\$MAXSIGWIDTH = $MAXSIGWIDTH;				# Set maximum pixel width for images in the signature, 0 disables this limit
\$MAXSIGHEIGHT = $MAXSIGHEIGHT;				# Set maximum pixel height for images in the signature, 0 disables this limit
</add before>

####################################################################################

<edit file>
Sources/PrintPage.pl
</edit file>

<search for>
		$char_160 = chr(160);
		$threadpost =~ s~\[img\][\s*\t*\n*(&nbsp;)*($char_160)*]*(http\:\/\/)*(.+?)[\s*\t*\n*(&nbsp;)*($char_160)*]*\[/img\]~http://$2~isg;
		$threadpost =~ s~\[img width=(\d+) height=(\d+)\][\s*\t*\n*(&nbsp;)*($char_160)*]*(http\:\/\/)*(.+?)[\s*\t*\n*(&nbsp;)*($char_160)*]*\[/img\]~http://$4~isg;
</search for>

<replace>
		$char_160 = chr(160);
		$threadpost =~ s~\[img(.*?)\](?:\s|\t|\n|&nbsp;|$char_160)*(?:http(s)?\:\/\/)*(.+?)(?:\s|\t|\n|&nbsp;|$char_160)*\[/img\]~http$2://$3~isg;
</replace>

####################################################################################

<edit file>
Sources/YaBBC.pl
</edit file>

<search for>
$MAXIMGWIDTH = 400;
$MAXIMGHEIGHT = 500;
sub restrictimage {
	my($w,$h,$s) = @_;
	$w = $w <= $MAXIMGWIDTH ? $w : $MAXIMGWIDTH;
	$h = $h <= $MAXIMGHEIGHT ? $h : $MAXIMGHEIGHT;
	return qq~<img src="$s" width="$w" height="$h" alt="" border="0">~;
}
</search for>

<replace>
$MAXIMGWIDTH = $MAXIMGWIDTH || 0;
$MAXIMGHEIGHT = $MAXIMGHEIGHT || 0;
sub restrictimage {
	my($tmpstuff,$s) = @_;
	if ($s !~ m/^http(s)?\:\/\/.*\.(gif|jpg|jpeg|png|bmp)$/i) {return qq~$s~;}
	my ($dummy, $key, $value, $a, $b, $c);
	undef %parameter;
	foreach $dummy (split(/\s+/, $tmpstuff)) {
		($key, $value) = split(/=/,$dummy);
		&FromHTML($value);
		$parameter{$key} = $value;
	}
	$parameter{'width'} =~ s~\D~~g;
	$parameter{'height'} =~ s~\D~~g;
	$parameter{'align'} =~ s~\W~~g;
	&ToHTML($parameter{'alt'});
	$parameter{'alt'} =~ s~_~ ~g;
	if ($parameter{'align'} eq "") {$a = "";} else {$a = qq~ align="$parameter{'align'}"~;}
	if ($parameter{'width'} eq "") {$b = "";$parameter{'width'} = "0";} else {$b = qq~ width="$parameter{'width'}"~;}
	if ($parameter{'height'} eq "") {$c = "";$parameter{'height'} = "0";} else {$c = qq~ height="$parameter{'height'}"~;}

	return qq~<img src="$s"$a$b$c style="display:none" onerror="javascript: this.style.display = 'inline'" onload="javascript: if (this.style.display == 'none') {resize_img(this, $MAXIMGWIDTH, $MAXIMGHEIGHT, $parameter{'width'}, $parameter{'height'})}" alt="$parameter{'alt'}" border="0">~;
}
</replace>

<search for>
	$char_160 = chr(160);
	$message =~ s~\[img\][\s*\t*\n*(&nbsp;)*($char_160)*]*(http\:\/\/)*(.+?)[\s*\t*\n*(&nbsp;)*($char_160)*]*\[/img\]~<img src="http\:\/\/$2" alt="" border="0">~isg;
	$message =~ s~\[img width=(\d+) height=(\d+)\][\s*\t*\n*(&nbsp;)*($char_160)*]*(http\:\/\/)*(.+?)[\s*\t*\n*(&nbsp;)*($char_160)*]*\[/img\]~restrictimage($1,$2,'http://'.$4)~eisg;
</search for>

<replace>
	$char_160 = chr(160);
	$message =~ s~\[img(.*?)\](?:\s|\t|\n|&nbsp;|$char_160)*(?:http(s)?\:\/\/)*(.+?)(?:\s|\t|\n|&nbsp;|$char_160)*\[/img\]~restrictimage($1, 'http'.$2.'://'.$3)~eisg;
</replace>

####################################################################################
###                The following step resizes the user's signature               ###
####################################################################################

<edit file>
Sources/Load.pl
</edit file>

<search for>
	if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
</search for>

<replace>
	if($enable_ubbc) {
		$tmp_max_width = $MAXIMGWIDTH; $tmp_max_height = $MAXIMGHEIGHT;		# store maximum image size
		$MAXIMGWIDTH = $MAXSIGWIDTH; $MAXIMGHEIGHT = $MAXSIGHEIGHT;		# set limits to maximum signature size
		if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC;
		$MAXIMGWIDTH = $tmp_max_width; $MAXIMGHEIGHT = $tmp_max_height;		# restore maximum image size
	}
</replace>

####################################################################################
###                 The following steps resize the user's avatar                 ###
####################################################################################

<edit file>
Sources/Load.pl
</edit file>

<search for>
		$userprofile{$user}->[13] = $userprofile{$user}->[13] =~ m~\A[\s\n]*http://~i ? qq~<br><img src="$userprofile{$user}->[13]"$userpic_tmpwidth$userpic_tmpheight border="0" alt=""><br><br>~ : qq~<br><img src="$facesurl/$userprofile{$user}->[13]" border="0" alt=""><br>~;
</search for>

<replace>
		$userprofile{$user}->[13] = $userprofile{$user}->[13] =~ m~\A[\s\n]*http://~i ? qq~<br><img src="$userprofile{$user}->[13]"$userpic_tmpwidth$userpic_tmpheight style="display:none" onerror="javascript: this.style.display = 'inline'" onload="javascript: if (this.style.display == 'none') {resize_img(this, $userpic_width, $userpic_height, 0, 0)}" alt="" border="0"><br><br>~ : qq~<br><img src="$facesurl/$userprofile{$user}->[13]" border="0" alt=""><br>~;
</replace>

####################################################################################

<edit file>
Sources/Profile.pl
</edit file>

<search for>
                $pic .= qq~<img src="$memsettings[13]" $tmp_width $tmp_height border="0" alt=""></a>~;
</search for>

<replace>
                $pic .= qq~<img src="$memsettings[13]" $tmp_width $tmp_height style="display:none" onerror="javascript: this.style.display = 'inline'" onload="javascript: if (this.style.display == 'none') {resize_img(this, $userpic_width, $userpic_height, 0, 0)}" alt="" border="0"></a>~;
</replace>